-- Preparation:

USE ContosoRetailDW;

CREATE NONCLUSTERED COLUMNSTORE INDEX nci_FactOnlineSales
ON dbo.FactOnlineSales (OnlineSalesKey,
                        DateKey,
                        StoreKey,
                        ProductKey,
                        PromotionKey,
                        CurrencyKey,
                        CustomerKey,
                        SalesOrderNumber,
                        SalesOrderLineNumber,
                        SalesQuantity,
                        SalesAmount,
                        ReturnQuantity,
                        ReturnAmount,
                        DiscountQuantity,
                        DiscountAmount,
                        TotalCost,
                        UnitCost,
                        UnitPrice,
                        ETLLoadID,
                        LoadDate,
                        UpdateDate);


-- Demo 1:

USE ContosoRetailDW;

DECLARE @up money = 9.99;

SELECT     SUM (CAST (c.CustomerKey AS bigint)), SUM (s.TotalCost)
FROM       dbo.FactOnlineSales AS s
INNER JOIN dbo.DimCustomer     AS c
   ON      c.CustomerKey = s.CustomerKey
WHERE      s.UnitPrice = @up
OPTION (OPTIMIZE FOR (@up = 320.00) , ORDER GROUP);


-- Demo 2:

USE ContosoRetailDW;

DECLARE @n int = 1;

SELECT      *
FROM       (SELECT TOP (@n) * FROM dbo.FactOnlineSales) AS fos
INNER JOIN  dbo.DimCustomer                             AS dc
      ON    dc.CustomerKey = fos.CustomerKey;


-- Demo 3:

USE ContosoRetailDW;

DECLARE @n int = 70000;

SELECT     MAX (CHECKSUM (*))
FROM      (SELECT TOP (@n) *,
                           REPLICATE (LEFT(SalesOrderNumber, 1), 4000) AS x,
                           REPLICATE (LEFT(SalesOrderNumber, 1), 3999) AS y,
                           REPLICATE (LEFT(SalesOrderNumber, 1), 3998) AS z,
                           REPLICATE (LEFT(SalesOrderNumber, 1), 3997) AS a,
                           REPLICATE (LEFT(SalesOrderNumber, 1), 3996) AS b,
                           REPLICATE (LEFT(SalesOrderNumber, 1), 3995) AS c,
                           REPLICATE (LEFT(SalesOrderNumber, 1), 3994) AS d,
                           REPLICATE (LEFT(SalesOrderNumber, 1), 3993) AS e,
                           REPLICATE (LEFT(SalesOrderNumber, 1), 3992) AS f,
                           REPLICATE (LEFT(SalesOrderNumber, 1), 3991) AS g,
                           REPLICATE (LEFT(SalesOrderNumber, 1), 3980) AS h,
                           REPLICATE (LEFT(SalesOrderNumber, 1), 3989) AS i,
                           REPLICATE (LEFT(SalesOrderNumber, 1), 3988) AS j,
                           REPLICATE (LEFT(SalesOrderNumber, 1), 3987) AS k,
                           REPLICATE (LEFT(SalesOrderNumber, 1), 3986) AS l,
                           REPLICATE (LEFT(SalesOrderNumber, 1), 3985) AS m,
                           REPLICATE (LEFT(SalesOrderNumber, 1), 3984) AS n
           FROM   dbo.FactOnlineSales) AS s1
INNER JOIN dbo.FactOnlineSales         AS s2
   ON      s2.OnlineSalesKey = s1.OnlineSalesKey
OPTION (OPTIMIZE FOR (@n = 1));


-- Demo 4:

USE ContosoRetailDW;

--SET STATISTICS IO ON;

DECLARE @n int = 1000000;

SELECT     fos.OnlineSalesKey,
           dc.LastName
FROM      (SELECT TOP (@n) * FROM dbo.FactOnlineSales) AS fos
INNER JOIN dbo.DimCustomer                             AS dc
   ON      dc.CustomerLabel = 'CS' + RIGHT(CAST (fos.ProductKey AS varchar(30)), 3)
OPTION (OPTIMIZE FOR (@n = 138),
        USE HINT ('DISABLE_BATCH_MODE_ADAPTIVE_JOINS'));
